unit umain;

{$mode objfpc}{$H+}
{$modeswitch nestedprocvars}

interface

uses
  cthreads, uev3webcam, ucontrols, GraphType, IntfGraphics, Classes, SysUtils,
  LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls, StdCtrls,
  Spin, Buttons;


type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    Button2: TButton;
    bwDelta: TSpinEdit;
    bwBorder: TSpinEdit;
    fileIndex: TSpinEdit;
    fileName: TEdit;
    fileFormat: TComboBox;
    DeviceNum: TSpinEdit;
    ConnBox: TGroupBox;
    fBox: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LBox: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    PBox: TPaintBox;
    bwRadius: TSpinEdit;
    VCBrightness: TVControlFrame;
    VCContrast: TVControlFrame;
    VCHue: TVControlFrame;
    VCGamma: TVControlFrame;
    VCSharpness: TVControlFrame;
    VCSaturation: TVControlFrame;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bwBorderChange(Sender: TObject);
    procedure bwDeltaChange(Sender: TObject);
    procedure bwRadiusChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PBoxPaint(Sender: TObject);
    procedure CamConnect();
    procedure fileSave();

  private

  public

  end;

  { TVideoThread }

  TVideoThread=class(TThread)
    procedure execute();override;
    procedure sync;
  end;

var
  Form1: TForm1;
  vt:TVideoThread=nil;
  b,gr,bw,bw1:tBitmap; // цветной, серый, ч/б, ч/б с дин.анализом
  gray:TCamImageGray; // промежуточный
  Radius:integer=1;
  Delta:integer=1;
  Border:integer=127;
  // размеры отрисовки
  paintWidth:integer=320;
  paintHeight:integer=240;
  // размеры кадра
  camWidth:integer=320;


implementation
uses dateutils;
{ TVideoThread }

procedure TVideoThread.execute();
begin
 while not terminated do begin
  with webcam do begin
   CaptureImageYUYV();
   dec_yuyv_bgra(ImageYUYV,b.RawImage.Data,Width,Height);
   dec_yuyv_gray(ImageYUYV,gray.Data,Width,Height);
   dec_gray_bgra(gray.Data,gr.RawImage.Data,Width,Height);
   dec_yuyv_bw(ImageYUYV,gray.data,Width,Height,Border);
   dec_gray_bgra(gray.data,bw.RawImage.Data,Width,Height);
   dec_yuyv_bwdynamic(ImageYUYV,gray.data,Width,Height,Width div radius,Height div radius,delta);
   dec_gray_bgra(gray.data,bw1.RawImage.Data,Width,Height);
  end;
  synchronize(@sync);
 end;
end;

procedure TVideoThread.sync;
begin
 if webcam.lasterror<>'' then begin
  form1.enabled:=false;
  showmessage('Фатальная ошибка работы с камерой:'#10#10+webcam.lasterror+#10#10'Перезапустите приложение.');
  webcam.lasterror:='';
  vt.terminate;
  exit;
 end;
 b.BeginUpdate();
 b.EndUpdate();
 bw.BeginUpdate();
 bw.EndUpdate();
 bw1.BeginUpdate();
 bw1.EndUpdate();
 gr.BeginUpdate();
 gr.EndUpdate();

 form1.PBox.invalidate;
end;

{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
 begin
 VCBrightness.BindControl('Яркость',webcam.Brightness);
 VCContrast.BindControl('Контраст',webcam.Contrast);
 VCSaturation.BindControl('Насыщенность',webcam.Saturation);
 VCHue.BindControl('Оттенок',webcam.Hue);
 VCGamma.BindControl('Гамма',webcam.Gamma);
 VCSharpness.BindControl('Четкость',webcam.Sharpness);

 b:=tbitmap.Create;
 gr:=tbitmap.Create;
 bw:=tbitmap.Create;
 bw1:=tbitmap.Create;
 gray:=TCamImageGray.Create(Width,Height);
 lbox.Enabled:=false;
 fbox.Enabled:=false;
end;

procedure TForm1.bwRadiusChange(Sender: TObject);
begin
 Radius:=(sender as TSpinEdit).value;
end;

procedure TForm1.bwDeltaChange(Sender: TObject);
begin
 Delta:=(sender as TSpinEdit).value;
end;

procedure TForm1.bwBorderChange(Sender: TObject);
begin
   Border:=(sender as TSpinEdit).value;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CamConnect();
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  fileSave();
end;

procedure TForm1.PBoxPaint(Sender: TObject);
begin
 (sender as TPaintBox).canvas.stretchdraw(bounds(0,0,paintWidth,paintHeight),b);
 (sender as TPaintBox).canvas.stretchdraw(bounds(10+paintWidth,0,paintWidth,paintHeight),gr);
 (sender as TPaintBox).canvas.stretchdraw(bounds(2*(10+paintWidth),0,paintWidth,paintHeight),bw);
 (sender as TPaintBox).canvas.stretchdraw(bounds(3*(10+paintWidth),0,paintWidth,paintHeight),bw1);
end;

procedure TForm1.CamConnect();
 var error:boolean=false;
begin
 Lbox.Enabled:=false;
 fbox.Enabled:=false;


 if assigned(vt) then begin
   vt.Terminate;
   vt.WaitFor;
   vt.Free;
   vt:=nil;
 end;

 webcam.DeviceClose;
 if not webcam.DeviceOpen(deviceNum.Value,camWidth) then begin
   error:=true;
   showMessage('Ошибка инициализации вебкамеры: '+webcam.lasterror);
 end;
 VCBrightness.BindControl('Яркость',webcam.Brightness);
 VCContrast.BindControl('Контраст',webcam.Contrast);
 VCSaturation.BindControl('Насыщенность',webcam.Saturation);
 VCHue.BindControl('Оттенок',webcam.Hue);
 VCGamma.BindControl('Гамма',webcam.Gamma);
 VCSharpness.BindControl('Четкость',webcam.Sharpness);

 b.setsize(webcam.width,webcam.height);
 gr.setsize(webcam.width,webcam.height);
 bw.setsize(webcam.width,webcam.height);
 bw1.setsize(webcam.width,webcam.height);
 if not error then begin
   Lbox.Enabled:=true;
   fbox.Enabled:=true;
   vt:=TVideoThread.Create(false);
 end;
end;

procedure TForm1.fileSave();
 var cImg:TCamImageBGRA;
     fn:string;
begin
 enabled:=false;
 Application.ProcessMessages;
 if assigned(vt) then begin
   vt.Terminate;
   vt.WaitFor;
   vt.Free;
   vt:=nil;
 end;
 cImg:=TCamImageBGRA.Create(b.Width,b.Height);

 fn:=fileName.Text+format('%.5d',[fileIndex.value])+'.'+fileFormat.Text;
 fileIndex.value:=fileIndex.value+1;
 move(b.RawImage.Data^,cImg.Data^,b.RawImage.DataSize);
 cImg.SaveToFile('Color_'+fn);
 move(gr.RawImage.Data^,cImg.Data^,gr.RawImage.DataSize);
 cImg.SaveToFile('Gray_'+fn);
 move(bw.RawImage.Data^,cImg.Data^,bw.RawImage.DataSize);
 cImg.SaveToFile('BW_'+fn);
 move(bw1.RawImage.Data^,cImg.Data^,bw1.RawImage.DataSize);
 cImg.SaveToFile('BWDyn_'+fn);

 vt:=TVideoThread.Create(false);
 enabled:=true;
end;

initialization
  {$I umain.lrs}

end.

